﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using Demo.Threading.WaitHandles;

namespace Demo.Threading.ResetEvents
{
    class Program
    {        
        static void Main(string[] args)
        {
            Demo_ResetEvent();
            Console.WriteLine("Press a key to continue..");
            Console.ReadLine();
            Demo_AutoResetEvent();
            Console.WriteLine("Press a key to continue..");
            Console.ReadLine();
            Demo_ManualResetEvent();
            Console.WriteLine("Press a key to continue..");         
            Console.ReadLine();
        }

        public static void Demo_ResetEvent()
        {
            Console.WriteLine("Demo Normal Reset Event...");
            Server s = new Server();
            ThreadPool.QueueUserWorkItem(new WaitCallback((o) =>
            {
                s.DoWork();                
            }));

            ((AutoResetEvent)Global.GetHandle(Handles.AutoResetEvent)).WaitOne();
            Console.WriteLine("Work complete signal received");
        }

        public static void Demo_AutoResetEvent()
        {
            Console.WriteLine("Demo Autoreset event...");
            Server s = new Server();

            Console.WriteLine("Start Thread 1..");
            ThreadPool.QueueUserWorkItem(new WaitCallback((o) =>
            {
                s.DoWork(1, 4000);  
                
            }));            

            Console.WriteLine("Start Thread 2..");
            ThreadPool.QueueUserWorkItem(new WaitCallback((o) =>
            {
                s.DoWork(2, 4000);                
                
            }));

            s.UpdateLog(1);
            s.UpdateLog(2);
        }

        public static void Demo_ManualResetEvent()
        {
            Console.WriteLine("Demo Mnaulreset event...");
            Server s = new Server();
            ThreadPool.QueueUserWorkItem(new WaitCallback((o) =>
            {
                s.SendMessages(true);
            }));

            Console.WriteLine("Press 1 to send messages");
            Console.WriteLine("Prress 2 to stop messages");

            while (true)
            {               
                int input = Convert.ToInt16(Console.ReadLine());                              

                switch (input)
                {
                    case 1:
                        Console.WriteLine("Starting to send message ...");                        
                        ((ManualResetEvent)Global.GetHandle(Handles.ManualResetEvent)).Set();
                        break;
                    case 2:                                                
                        ((ManualResetEvent)Global.GetHandle(Handles.ManualResetEvent)).Reset();
                        Console.WriteLine("Message Stopped ..."); 
                        break;
                    default:
                        Console.WriteLine("Invalid Input");
                        break;
                }

            }            
        }
    }
}
