﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace Demo.Threading.DeadLock
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                DeadLock deadLock = new DeadLock();

                Thread tA = new Thread(new ThreadStart(deadLock.OperationA));
                Thread tB = new Thread(new ThreadStart(deadLock.OperationB));

                Console.WriteLine("Starting Thread A");
                tA.Start();
                
                Console.WriteLine("Starting Thread B");
                tB.Start();
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception : " + ex.Message);
            }

            finally
            {
                Console.ReadLine();
            }            
        }
    }

    public class DeadLock
    {        
        static object lockA = new object();
        static object lockB = new object();

        public void OperationA()
        {            
            lock (lockA)
            {
                Console.WriteLine("Thread {0} has locked Obect A", Thread.CurrentThread.ManagedThreadId);
                lock (lockB)
                {
                    Console.WriteLine("Thread {0} has locked Obect B", Thread.CurrentThread.ManagedThreadId);
                }
                Console.WriteLine("Thread {0} has released Obect B", Thread.CurrentThread.ManagedThreadId);
            }
            Console.WriteLine("Thread {0} has released Obect A", Thread.CurrentThread.ManagedThreadId);
        }

        public void OperationB()
        {            
            lock (lockB)
            {
                Console.WriteLine("Thread {0} has locked Obect B", Thread.CurrentThread.ManagedThreadId);
                lock (lockA)
                {
                    Console.WriteLine("Thread {0} has locked Obect A", Thread.CurrentThread.ManagedThreadId);
                }
                Console.WriteLine("Thread {0} has released Obect A", Thread.CurrentThread.ManagedThreadId);
            }
            Console.WriteLine("Thread {0} has released Obect B", Thread.CurrentThread.ManagedThreadId);
        }
    }
}
