﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.ComponentModel;

namespace Demo.Threading.Exception
{
    class Program
    {
        delegate void delDoWork();
        static void Main(string[] args)
        {           
            try
            {
                Console.WriteLine("Checking Exception with Thread class...");
                new Thread(new ThreadStart(DoWork)).Start();
                Console.WriteLine("Checking Exception with Delegates...");
                delDoWork del = new delDoWork(DoWork);
                del.BeginInvoke(CallBack, null);
                Console.WriteLine("Checking Exception with BackGroundWorker...");
                BackgroundWorker worker = new BackgroundWorker();
                worker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(worker_RunWorkerCompleted);
                worker.DoWork += new DoWorkEventHandler(worker_DoWork);
                worker.RunWorkerAsync();
                Console.WriteLine("Do work Sync..");
                DoWorkSync();
            }
            catch (System.Exception ex)
            {
                Console.WriteLine("Exception @ Main Thread" + ex.Message);
            }
            finally
            {
                Console.ReadLine();
            }
            
        }

        static void worker_DoWork(object sender, DoWorkEventArgs e)
        {
            //Thread.Sleep(3000);
            //throw new System.Exception("Thread Exception");
            try
            {
                Thread.Sleep(3000);
                throw new System.Exception("Thread Exception");
            }
            catch (System.Exception ex)
            {
                Console.WriteLine("Exception encountered at background thread " + ex.Message);
            }     
        }

        static void worker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            try
            {
                Console.WriteLine("Worker Completed");
            }
            catch (System.Exception)
            {
                
                throw;
            }
            
        }
        static void DoWorkSync()
        {
            //throw new System.Exception("Thread Exception");
            try
            {
                throw new System.Exception("Thread Exception");
            }
            catch (System.Exception)
            {
                
                throw;
            }
        }

        static void DoWork()
        {
            //Thread.Sleep(3000);
            //throw new System.Exception("Thread Exception");
            try
            {
                Thread.Sleep(3000);
                throw new System.Exception("Thread Exception");
            }
            catch (System.Exception ex)
            {
                Console.WriteLine("Exception encountered at background thread " + ex.Message);
            }            
        }

        static void CallBack(IAsyncResult ar)
        {
            try
            {
                Console.WriteLine("Callback received..");
            }
            catch (System.Exception)
            {
                
                throw;
            }
            
        }
    }
}
