﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace Demo.Threading.Locks
{
    // lock (this) is a problem if the instance can be accessed publicly.
    // lock (typeof (MyType)) is a problem if MyType is publicly accessible.
    // lock("myLock") is a problem because any other code in the process using the same string, will share the same lock.
    class Program
    {
        static int counter = 15;
        static int num = 1000;
        static Random r = new Random();

        static void Main(string[] args)
        {
            new Thread(new ParameterizedThreadStart((o) =>
            {
                    IncrementCounter(1);                    
            })).Start();
            new Thread(new ParameterizedThreadStart((o) =>
            {
                IncrementCounter(2);                

            })).Start();

            new Thread(new ParameterizedThreadStart((o) =>
            {
                IncrementCounter(3);                

            })).Start();

            Console.ReadLine();

            new Thread(new ParameterizedThreadStart((o) =>
            {                
                DecrementCounter(r.Next(1, 5));
            })).Start();
            new Thread(new ParameterizedThreadStart((o) =>
            {                
                DecrementCounter(r.Next(1, 5));

            })).Start();

            new Thread(new ParameterizedThreadStart((o) =>
            {                
                DecrementCounter(r.Next(1, 5));

            })).Start();

            Console.ReadLine();
        }

        public static void IncrementCounter(int number)
        {
            object syncLock = new object();
            lock (syncLock)
            {
                for (int i = 0; i < 3; i++)
                {                                 
                    counter += number;
                    Console.WriteLine("Thread : {0}, Increment by {1}, Counter : {2}",
                        Thread.CurrentThread.ManagedThreadId, number, counter);                    
                }      
            }
                  
        }

        public static void DecrementCounter(int number)
        {
            object syncLock = new object();                         
            lock (syncLock)
            {                             
                Console.WriteLine("Thread : {0}, Counter {1}, Decrement by {2}, Counter : {3}",
                    Thread.CurrentThread.ManagedThreadId, counter, number, counter -= number);                
            }       

        }
    }
}
