﻿/*
When Not to Use Thread Pool Threads -

You require a foreground thread.
You require a thread to have a particular priority.
You have tasks that cause the thread to block for long periods of time. The thread pool has a maximum number of threads, so a large number of blocked thread pool threads might prevent tasks from starting.
You need to place threads into a single-threaded apartment. All ThreadPool threads are in the multithreaded apartment.
You need to have a stable identity associated with the thread, or to dedicate a thread to a task.
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace Demo.Threading.Threadpool
{
    class Program
    {
        static void Main(string[] args)
        {
            WaitCallback threadCallback = new WaitCallback(HeavyOperation);

            for (int i = 0; i < 3; i++)
			{
                System.Threading.ThreadPool.QueueUserWorkItem(HeavyOperation, i);			 
			}
            
            Console.ReadLine();
        }

        private static void HeavyOperation(object WorkItem)
        {
            System.Threading.Thread.Sleep(5000);
            Console.WriteLine("Executed work Item {0}", (int)WorkItem);
        }
    }
}
